Subject: Re: stdcall lib functions with exception throwing callbacks vs Dwarf2 EH
From: Danny Smith <[email-masked]>
To: Richard Henderson <[email-masked]>
Cc: [email-masked], Cygwin <[email-masked]>, mingw-dvlpr <[email-masked]>
Date: Wed, 24 Nov 2004 21:09:52 +1300

Richard Henderson wrote:
> On Wed, Nov 24, 2004 at 11:27:11AM +1300, Danny Smith wrote:
>> Before I pull any more hair out trying, does any one have any hints
>> on how to use an MD_FALLBACK_FRAME_STATE_FOR to workaround ...
>
> That would be wrong.
>
> I think the most likely explanation is that there's a bug in the
> dwarf2 generator for stdcall functions with -fomit-frame-pointer,
> and the problem should be attacked there.
>

There does seem to be a  problem in the frame-pointer handling see:

http://gcc.gnu.org/ml/gcc/2002-11/msg00149.html

With this testcase:
void __attribute__((stdcall)) test( int a) { a; }

 void snafu( void) {
      test( 666);
      throw 999;
 }

 int main( void) {
      try {
          snafu( );
  return 0;
      } catch( ...) {
          return 1;
      }
 }

I get (today):

g++ -fno-omit-frame-pointer PASS (at all optimisation levels).

g++ -O{0|1|2} -fomit-frame-pointer -maccumulate-outgoing-args PASS.

g++  -O0 -mtune=i686  -mno-accumulate-outgoing-args -fomit-frame-pointer
FAIL
g++ -O{1,2}  -mtune=i686  -mno-accumulate-outgoing-args -fomit-frame-poi
nter  PASS

The optimisation flags that cause failure has changed since the original
gcc report.

Danny

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/